import java.io.*;

public class FileSender {
	
	public static String root = "root/";
	
	private Request req;
	private Response res;
	private File f;
	
	public FileSender(Request req, Response res) {
		this.req = req;
		this.res = res;
		
		f = new File(root + req.getPath() + req.getObject());
		if (f.isDirectory())
			f = new File(f, "index.html");
	}
	
	public String getFullName()
	throws IOException {
		return f.getPath();
	}
	
	public void handle()
	throws FileNotFoundException, IOException {
		try {
			PrintStream out = res.getOutputStream();
			FileInputStream readf = new FileInputStream(f);

			String mime = mimeType(getExtension(f));
			if (mime != null)
				res.setContentType(mime);
			res.sendHeaders();

			int length;
			byte[] buff = new byte[1024];
			while((length = readf.read(buff)) > 0){
				out.write(buff,0,length);
			}
			readf.close();
		}
		catch (FileNotFoundException fnf) {
			Output.err.println(fnf.getLocalizedMessage());
			String msg = "<H1>Error 404:</H1><BR>\r\n";
			msg += "<H1>File not found on server</H1><BR>\r\n";
			res.sendError(res.SC_NOT_FOUND, msg);
		}
		catch (IOException io) {
			Output.err.println(io.getLocalizedMessage());
			io.printStackTrace();
		}
	}
	
	private String mimeType(String ext) {
		if (ext.equals("html"))
			return "text/html";
		else if (ext.equals("txt"))
			return "text/plain";
		else if (ext.equals("gif"))
			return "image/gif";
		else if (ext.equals("jpg"))
			return "image/jpeg";
		return null;
	}
	
	private String getExtension(File f) {
		String name = f.getName();
		int i = name.lastIndexOf('.');
		if (i == -1)
			return "";
		return name.substring(i + 1);
	}
}


