/*=============================================================================
author        :Walter Schreppers & Nhan Truong
filename      :JspPage.java
created       :26/01/2001
modified      :28/01/2001
version       :1
bugreport(log):/
=============================================================================*/


import java.net.*;
import java.io.*;


/*----------------------------------------------------------------------------
We open the .jsp file and parse the <% ... %> and the <%= ... %> tags.
Everything outside these tags will become out.println("html stuff...");
The variable inside  <%= ... %> tags will be converted into 
out.println(somevariable...);
The statements within <% ... %> will be copied literally to the .java file
-----------------------------------------------------------------------------*/

public class JspPage{

	public static String root = "root/";

	private String name;
	private String dir;
	
	public JspPage(String dir, String name) {
		this.name = name;
		this.dir = dir;
	}
	
	public String getName() {
		return name;
	}
	
	public String getFullName() {
		return root + dir + name;
	}
	
	public void jspToJava()
	throws FileNotFoundException, IOException {
		FileReader source = new FileReader(root + dir + name + ".jsp");
		FileWriter target = new FileWriter(root + dir + name + ".java");

		Output.out.print(getFullName() + ".jsp:  parsing (jsp -> java) ... ");
		JspParser parser = new JspParser(name, source, target);
		parser.parse();
		Output.out.println("done.");
	}

	public boolean modified() {
		File jsp=new File(root + dir + name + ".jsp");
		File cls=new File(root + dir + name + ".class");
		return ((cls.lastModified() < jsp.lastModified()) || (!cls.exists()));
	}
	
	public void execute(Request req,Response res)
	throws ClassNotFoundException, InstantiationException, IllegalAccessException {
		Output.out.print(getFullName() + ".class:  executing ... ");
		JSPBase jspObject = (JSPBase) Class.forName(name).newInstance();
		res.setContentType("text/html");
		res.sendHeaders();
		
		jspObject.init();
		jspObject.service(req,res); //execute it !
		jspObject.destroy();
		
		Output.out.println("done.");
	}
	
}


